import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Target is just a transparent Greenfoot Image that interacts with flying ants to determine
 * if they intersect the target zone. It is placed over the goal object (in this case pants).
 * 
 * @author JDB
 * @version March 2011
 */
public class Target  extends Actor
{
    int score = 0;
    int antCount = 0;
    Label lblScore = new Label("Score : ");
    boolean antGoingDown = false;
    
    

    /** 
     * Constructor for Target, receive width and height of the target and
     * construct a transparent image.
     */
    public Target(int x, int y, Label lbl, int antCount)
    {
        GreenfootImage img = new GreenfootImage(x, y);
        img.clear();
        setImage(img);
        lblScore = lbl;
        
    }
    /**
     * Act - do whatever the Target wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        checkForAnt();
        updateScore();
    }    
    
    public void checkForAnt()
    {
        Actor antInPants;
        antInPants = this.getOneIntersectingObject(Ant.class);
        if(antInPants != null)
        {
            if(antGoingDown)
            {
                getWorld().removeObject(antInPants);
                Greenfoot.playSound("ding.wav");
                score++; 
                antGoingDown = false;
            }
        }
    }
    
    public void updateScore()
    {
        double percentage = Math.round(((double)score/ (double)antCount * 100));
        String outputText = "Score : " + score + " out of " + antCount + "  -  " + percentage + " %";
        lblScore.setText(outputText);
    }
    
    public void setGoingDown(boolean antGoingDown)
    {
        this.antGoingDown = antGoingDown;
    }
}
